diff --git a/plugins/scale.c b/plugins/scale.c
index 5b4df25..7046b17 100644
--- a/plugins/scale.c
+++ b/plugins/scale.c
@@ -151,7 +151,7 @@ scaleActivateEvent (CompScreen *s,
 
     o[0].type = CompOptionTypeInt;
     o[0].name = "root";
-    o[0].value.i = s->root;
+    o[0].value.i = s->root.id;
 
     o[1].type = CompOptionTypeBool;
     o[1].name = "active";
@@ -313,6 +313,9 @@ setScaledPaintAttributes (CompWindow        *w,
     SCALE_SCREEN (w->screen);
     SCALE_WINDOW (w);
 
+    if (w->parent != &w->screen->root)
+	return FALSE;
+
     if (sw->adjust || sw->slot)
     {
 	SCALE_DISPLAY (w->screen->display);
@@ -379,7 +382,12 @@ scalePaintWindow (CompWindow		  *w,
 	scaled = (*ss->setScaledPaintAttributes) (w, &sAttrib);
 
 	if (sw->adjust || sw->slot)
+	{
+	    if (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK)
+		return FALSE;
+
 	    mask |= PAINT_WINDOW_NO_CORE_INSTANCE_MASK;
+	}
 
 	UNWRAP (ss, s, paintWindow);
 	status = (*s->paintWindow) (w, &sAttrib, transform, region, mask);
@@ -387,16 +395,7 @@ scalePaintWindow (CompWindow		  *w,
 
 	if (scaled)
 	{
-	    FragmentAttrib fragment;
-	    CompTransform  wTransform = *transform;
-
-	    if (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK)
-		return FALSE;
-
-	    initFragmentAttrib (&fragment, &w->lastPaint);
-
-	    if (w->alpha || fragment.opacity != OPAQUE)
-		mask |= PAINT_WINDOW_TRANSLUCENT_MASK;
+	    CompTransform wTransform = *transform;
 
 	    matrixTranslate (&wTransform, w->attrib.x, w->attrib.y, 0.0f);
 	    matrixScale (&wTransform, sw->scale, sw->scale, 1.0f);
@@ -405,13 +404,7 @@ scalePaintWindow (CompWindow		  *w,
 			     sw->ty / sw->scale - w->attrib.y,
 			     0.0f);
 
-	    glPushMatrix ();
-	    glLoadMatrixf (wTransform.m);
-
-	    (*s->drawWindow) (w, &wTransform, &fragment, region,
-			      mask | PAINT_WINDOW_TRANSFORMED_MASK);
-
-	    glPopMatrix ();
+	    drawTransformedWindowWithChildren (w, NULL, &wTransform);
 
 	    (*ss->scalePaintDecoration) (w, &sAttrib, transform, region, mask);
 	}
@@ -742,7 +735,7 @@ layoutThumbs (CompScreen *s)
     ss->nWindows = 0;
 
     /* add windows scale list, top most window first */
-    for (w = s->reverseWindows; w; w = w->prev)
+    for (w = s->root.reverseWindows; w; w = w->prev)
     {
 	SCALE_WINDOW (w);
 
@@ -897,7 +890,7 @@ scalePreparePaintScreen (CompScreen *s,
 	{
 	    ss->moreAdjust = 0;
 
-	    for (w = s->windows; w; w = w->next)
+	    for (w = s->root.windows; w; w = w->next)
 	    {
 		SCALE_WINDOW (w);
 
@@ -962,7 +955,7 @@ scaleCheckForWindowAt (CompScreen *s,
     int        x1, y1, x2, y2;
     CompWindow *w;
 
-    for (w = s->reverseWindows; w; w = w->prev)
+    for (w = s->root.reverseWindows; w; w = w->prev)
     {
 	SCALE_WINDOW (w);
 
@@ -1028,7 +1021,7 @@ scaleTerminate (CompDisplay     *d,
     {
 	SCALE_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (ss->grab)
@@ -1048,7 +1041,7 @@ scaleTerminate (CompDisplay     *d,
 	    {
 		CompWindow *w;
 
-		for (w = s->windows; w; w = w->next)
+		for (w = s->root.windows; w; w = w->next)
 		{
 		    SCALE_WINDOW (w);
 
@@ -1102,7 +1095,7 @@ scaleEnsureDndRedirectWindow (CompScreen *s)
 	attr.override_redirect = TRUE;
 
 	ss->dndTarget = XCreateWindow (s->display->display,
-				       s->root,
+				       s->root.id,
 				       0, 0, 1, 1, 0,
 				       CopyFromParent,
 				       InputOnly,
@@ -1420,7 +1413,7 @@ scaleMoveFocusWindow (CompScreen *s,
 	    cx = (sw->slot->x1 + sw->slot->x2) / 2;
 	    cy = (sw->slot->y1 + sw->slot->y2) / 2;
 
-	    for (w = s->windows; w; w = w->next)
+	    for (w = s->root.windows; w; w = w->next)
 	    {
 		slot = GET_SCALE_WINDOW (w, ss)->slot;
 		if (!slot)
@@ -1453,7 +1446,7 @@ scaleMoveFocusWindow (CompScreen *s,
 
 	SCALE_SCREEN (s);
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    if (!GET_SCALE_WINDOW (w, ss)->slot)
 		continue;
@@ -1548,7 +1541,7 @@ scaleWindowRemove (CompDisplay *d,
 
 			o.type    = CompOptionTypeInt;
 			o.name    = "root";
-			o.value.i = w->screen->root;
+			o.value.i = w->screen->root.id;
 
 			opt = SCALE_DISPLAY_OPTION_INITIATE_EDGE;
 			action = &sd->opt[opt].value.action;
@@ -1592,7 +1585,7 @@ scaleHoverTimeout (void *closure)
 
 	o.type    = CompOptionTypeInt;
 	o.name    = "root";
-	o.value.i = s->root;
+	o.value.i = s->root.id;
 
 	option = SCALE_DISPLAY_OPTION_INITIATE_EDGE;
 	scaleTerminate (s->display, &sd->opt[option].value.action, 0, &o, 1);
@@ -1649,7 +1642,7 @@ scaleHandleEvent (CompDisplay *d,
 
 		    o.type    = CompOptionTypeInt;
 		    o.name    = "root";
-		    o.value.i = s->root;
+		    o.value.i = s->root.id;
 
 		    if (scaleSelectWindowAt (s,
 					     event->xbutton.x_root,
@@ -1788,7 +1781,7 @@ scaleHandleEvent (CompDisplay *d,
 
 		    o.type    = CompOptionTypeInt;
 		    o.name    = "root";
-		    o.value.i = w->screen->root;
+		    o.value.i = w->screen->root.id;
 
 		    option = SCALE_DISPLAY_OPTION_INITIATE_EDGE;
 		    scaleTerminate (d, &sd->opt[option].value.action,
@@ -1926,7 +1919,8 @@ scaleInitDisplay (CompPlugin  *p,
 {
     ScaleDisplay *sd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     sd = malloc (sizeof (ScaleDisplay));
diff --git a/plugins/screenshot.c b/plugins/screenshot.c
index 74f44ba..899b2f0 100644
--- a/plugins/screenshot.c
+++ b/plugins/screenshot.c
@@ -122,7 +122,7 @@ shotTerminate (CompDisplay     *d,
     {
 	SHOT_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (ss->grabIndex)
@@ -436,7 +436,8 @@ shotInitDisplay (CompPlugin  *p,
 {
     ShotDisplay *sd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     sd = malloc (sizeof (ShotDisplay));
diff --git a/plugins/svg.c b/plugins/svg.c
index bd39174..0ebebbf 100644
--- a/plugins/svg.c
+++ b/plugins/svg.c
@@ -178,7 +178,7 @@ initSvgTexture (CompWindow *w,
 	XGetWindowAttributes (s->display->display, w->id, &attr);
 
 	depth = attr.depth;
-	texture->pixmap = XCreatePixmap (s->display->display, s->root,
+	texture->pixmap = XCreatePixmap (s->display->display, s->root.id,
 					 width, height, depth);
 
 	if (!bindPixmapToTexture (s,
@@ -795,7 +795,8 @@ svgInitDisplay (CompPlugin  *p,
     SvgDisplay *sd;
     CompScreen *s;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     sd = malloc (sizeof (SvgDisplay));
diff --git a/plugins/switcher.c b/plugins/switcher.c
index 13be8ad..b0acfec 100644
--- a/plugins/switcher.c
+++ b/plugins/switcher.c
@@ -328,7 +328,7 @@ switchActivateEvent (CompScreen *s,
 
     o[0].type = CompOptionTypeInt;
     o[0].name = "root";
-    o[0].value.i = s->root;
+    o[0].value.i = s->root.id;
 
     o[1].type = CompOptionTypeBool;
     o[1].name = "active";
@@ -415,7 +415,7 @@ switchCreateWindowList (CompScreen *s,
 
     ss->nWindows = 0;
 
-    for (w = s->windows; w; w = w->next)
+    for (w = s->root.windows; w; w = w->next)
     {
 	if (isSwitchWin (w))
 	    switchAddWindowToList (s, w);
@@ -475,7 +475,7 @@ switchToWindow (CompScreen *s,
 	    xev.xclient.format = 32;
 
 	    xev.xclient.message_type = s->display->desktopViewportAtom;
-	    xev.xclient.window = s->root;
+	    xev.xclient.window = s->root.id;
 
 	    xev.xclient.data.l[0] = x * s->width;
 	    xev.xclient.data.l[1] = y * s->height;
@@ -483,7 +483,7 @@ switchToWindow (CompScreen *s,
 	    xev.xclient.data.l[3] = 0;
 	    xev.xclient.data.l[4] = 0;
 
-	    XSendEvent (s->display->display, s->root, FALSE,
+	    XSendEvent (s->display->display, s->root.id, FALSE,
 			SubstructureRedirectMask | SubstructureNotifyMask,
 			&xev);
 	}
@@ -532,7 +532,7 @@ switchCountWindows (CompScreen *s)
     CompWindow *w;
     int	       count = 0;
 
-    for (w = s->windows; w && count < 5; w = w->next)
+    for (w = s->root.windows; w && count < 5; w = w->next)
 	if (isSwitchWin (w))
 	    count++;
 
@@ -600,7 +600,7 @@ switchInitiate (CompScreen            *s,
     if (count < 1)
 	return;
 
-    if (!ss->popupWindow && showPopup)
+    if (!ss->popupWindow && showPopup && s->root.substructureRedirect)
     {
 	Display		     *dpy = s->display->display;
 	XSizeHints	     xsh;
@@ -635,11 +635,11 @@ switchInitiate (CompScreen            *s,
 
 	attr.background_pixel = 0;
 	attr.border_pixel     = 0;
-	attr.colormap	      = XCreateColormap (dpy, s->root, visual,
+	attr.colormap	      = XCreateColormap (dpy, s->root.id, visual,
 						 AllocNone);
 
 	ss->popupWindow =
-	    XCreateWindow (dpy, s->root,
+	    XCreateWindow (dpy, s->root.id,
 			   s->width  / 2 - xsh.width / 2,
 			   s->height / 2 - xsh.height / 2,
 			   xsh.width, xsh.height, 0,
@@ -727,7 +727,7 @@ switchTerminate (CompDisplay     *d,
     {
 	SWITCH_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (ss->grabIndex)
@@ -989,7 +989,7 @@ switchWindowRemove (CompDisplay *d,
 
 	    o.type    = CompOptionTypeInt;
 	    o.name    = "root";
-	    o.value.i = w->screen->root;
+	    o.value.i = w->screen->root.id;
 
 	    switchTerminate (d, NULL, 0, &o, 1);
 	    return;
@@ -1322,8 +1322,9 @@ switchPaintOutput (CompScreen		   *s,
 		for (w = zoomed->prev; w && w->id <= 1; w = w->prev);
 		zoomedAbove = (w) ? w->id : None;
 
-		unhookWindowFromScreen (s, zoomed);
-		insertWindowIntoScreen (s, zoomed, s->reverseWindows->id);
+		unhookWindow (zoomed->parent, zoomed);
+		insertWindow (zoomed->parent, zoomed,
+			      zoomed->parent->reverseWindows->id);
 	    }
 	}
 	else
@@ -1356,8 +1357,8 @@ switchPaintOutput (CompScreen		   *s,
 
 	if (zoomed)
 	{
-	    unhookWindowFromScreen (s, zoomed);
-	    insertWindowIntoScreen (s, zoomed, zoomedAbove);
+	    unhookWindow (zoomed->parent, zoomed);
+	    insertWindow (zoomed->parent, zoomed, zoomedAbove);
 	}
 
 	if (switcher)
@@ -1445,7 +1446,6 @@ switchPaintThumb (CompWindow		  *w,
     if (w->texture->pixmap)
     {
 	AddWindowGeometryProc oldAddWindowGeometry;
-	FragmentAttrib	      fragment;
 	CompTransform	      wTransform = *transform;
 	int		      ww, wh;
 
@@ -1481,11 +1481,6 @@ switchPaintThumb (CompWindow		  *w,
 	sAttrib.xTranslate = wx - w->attrib.x + w->input.left * sAttrib.xScale;
 	sAttrib.yTranslate = wy - w->attrib.y + w->input.top  * sAttrib.yScale;
 
-	initFragmentAttrib (&fragment, &sAttrib);
-
-	if (w->alpha || fragment.opacity != OPAQUE)
-	    mask |= PAINT_WINDOW_TRANSLUCENT_MASK;
-
 	matrixTranslate (&wTransform, w->attrib.x, w->attrib.y, 0.0f);
 	matrixScale (&wTransform, sAttrib.xScale, sAttrib.yScale, 1.0f);
 	matrixTranslate (&wTransform,
@@ -1493,20 +1488,14 @@ switchPaintThumb (CompWindow		  *w,
 			 sAttrib.yTranslate / sAttrib.yScale - w->attrib.y,
 			 0.0f);
 
-	glPushMatrix ();
-	glLoadMatrixf (wTransform.m);
-
 	/* XXX: replacing the addWindowGeometry function like this is
 	   very ugly but necessary until the vertex stage has been made
 	   fully pluggable. */
 	oldAddWindowGeometry = w->screen->addWindowGeometry;
 	w->screen->addWindowGeometry = addWindowGeometry;
-	(w->screen->drawWindow) (w, &wTransform, &fragment, &infiniteRegion,
-				 mask);
+	drawTransformedWindowWithChildren (w, &sAttrib, &wTransform);
 	w->screen->addWindowGeometry = oldAddWindowGeometry;
 
-	glPopMatrix ();
-
 	if (ss->opt[SWITCH_SCREEN_OPTION_ICON].value.b)
 	{
 	    icon = getWindowIcon (w, ICON_SIZE, ICON_SIZE);
@@ -1634,6 +1623,12 @@ switchPaintWindow (CompWindow		   *w,
 	status = (*s->paintWindow) (w, attrib, transform, region, mask);
 	WRAP (ss, s, paintWindow, switchPaintWindow);
 
+	if (w->attrib.map_state != IsViewable)
+	    return status;
+
+	if (!w->damaged)
+	    return status;
+
 	if (!(mask & PAINT_WINDOW_TRANSFORMED_MASK) && region->numRects == 0)
 	    return TRUE;
 
@@ -1708,44 +1703,53 @@ switchPaintWindow (CompWindow		   *w,
 	status = (*s->paintWindow) (w, attrib, transform, region, mask);
 	WRAP (ss, s, paintWindow, switchPaintWindow);
     }
-    else if (ss->switching)
+    else if (w->parent == &s->root)
     {
-	WindowPaintAttrib sAttrib = *attrib;
-	GLuint            value;
-
-	value = ss->opt[SWITCH_SCREEN_OPTION_SATURATION].value.i;
-	if (value != 100)
-	    sAttrib.saturation = sAttrib.saturation * value / 100;
+	if (ss->switching)
+	{
+	    WindowPaintAttrib sAttrib = *attrib;
+	    GLuint            value;
 
-	value = ss->opt[SWITCH_SCREEN_OPTION_BRIGHTNESS].value.i;
-	if (value != 100)
-	    sAttrib.brightness = sAttrib.brightness * value / 100;
+	    value = ss->opt[SWITCH_SCREEN_OPTION_SATURATION].value.i;
+	    if (value != 100)
+		sAttrib.saturation = sAttrib.saturation * value / 100;
 
-	if (w->wmType & ~(CompWindowTypeDockMask | CompWindowTypeDesktopMask))
-	{
-	    value = ss->opt[SWITCH_SCREEN_OPTION_OPACITY].value.i;
+	    value = ss->opt[SWITCH_SCREEN_OPTION_BRIGHTNESS].value.i;
 	    if (value != 100)
-		sAttrib.opacity = sAttrib.opacity * value / 100;
-	}
+		sAttrib.brightness = sAttrib.brightness * value / 100;
 
-	if (ss->opt[SWITCH_SCREEN_OPTION_BRINGTOFRONT].value.b &&
-	    w->id == ss->zoomedWindow)
-	    zoomType = ZOOMED_WINDOW_MASK;
+	    if (w->wmType & ~(CompWindowTypeDockMask | CompWindowTypeDesktopMask))
+	    {
+		value = ss->opt[SWITCH_SCREEN_OPTION_OPACITY].value.i;
+		if (value != 100)
+		    sAttrib.opacity = sAttrib.opacity * value / 100;
+	    }
 
-	if (!(ss->zoomMask & zoomType))
-	    return (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK) ?
-		FALSE : TRUE;
+	    if (ss->opt[SWITCH_SCREEN_OPTION_BRINGTOFRONT].value.b &&
+		w->id == ss->zoomedWindow)
+		zoomType = ZOOMED_WINDOW_MASK;
 
-	UNWRAP (ss, s, paintWindow);
-	status = (*s->paintWindow) (w, &sAttrib, transform, region, mask);
-	WRAP (ss, s, paintWindow, switchPaintWindow);
+	    if (!(ss->zoomMask & zoomType))
+		return (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK) ?
+		    FALSE : TRUE;
+
+	    UNWRAP (ss, s, paintWindow);
+	    status = (*s->paintWindow) (w, &sAttrib, transform, region, mask);
+	    WRAP (ss, s, paintWindow, switchPaintWindow);
+	}
+	else
+	{
+	    if (!(ss->zoomMask & zoomType))
+		return (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK) ?
+		    FALSE : TRUE;
+
+	    UNWRAP (ss, s, paintWindow);
+	    status = (*s->paintWindow) (w, attrib, transform, region, mask);
+	    WRAP (ss, s, paintWindow, switchPaintWindow);
+	}
     }
     else
     {
-	if (!(ss->zoomMask & zoomType))
-	    return (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK) ?
-		FALSE : TRUE;
-
 	UNWRAP (ss, s, paintWindow);
 	status = (*s->paintWindow) (w, attrib, transform, region, mask);
 	WRAP (ss, s, paintWindow, switchPaintWindow);
@@ -1843,7 +1847,8 @@ switchInitDisplay (CompPlugin  *p,
 {
     SwitchDisplay *sd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     sd = malloc (sizeof (SwitchDisplay));
diff --git a/plugins/video.c b/plugins/video.c
index b95eb6b..6364e08 100644
--- a/plugins/video.c
+++ b/plugins/video.c
@@ -190,7 +190,7 @@ videoSetSupportedHint (CompScreen *s)
 	    data[n++] = vd->videoImageFormatAtom[i];
     }
 
-    XChangeProperty (s->display->display, s->root,
+    XChangeProperty (s->display->display, s->root.id,
 		     vd->videoSupportedAtom, XA_ATOM, 32,
 		     PropModeReplace, (unsigned char *) data, n);
 }
@@ -939,7 +939,7 @@ videoHandleEvent (CompDisplay *d,
 		    {
 			vs = GET_VIDEO_SCREEN (s, vd);
 
-			for (w = s->windows; w; w = w->next)
+			for (w = s->root.windows; w; w = w->next)
 			{
 			    if (w->shaded || w->mapNum)
 			    {
@@ -1045,7 +1045,8 @@ videoInitDisplay (CompPlugin  *p,
 {
     VideoDisplay *vd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     vd = malloc (sizeof (VideoDisplay));
@@ -1164,7 +1165,7 @@ videoFiniScreen (CompPlugin *p,
 
     freeWindowPrivateIndex (s, vs->windowPrivateIndex);
 
-    XDeleteProperty (s->display->display, s->root, vd->videoSupportedAtom);
+    XDeleteProperty (s->display->display, s->root.id, vd->videoSupportedAtom);
 
     videoDestroyFragmentFunctions (s, &vs->yv12Functions);
 
diff --git a/plugins/water.c b/plugins/water.c
index ef2f191..485060d 100644
--- a/plugins/water.c
+++ b/plugins/water.c
@@ -1040,6 +1040,7 @@ waterDrawWindowTexture (CompWindow	     *w,
 	Bool	       lighting = w->screen->lighting;
 	int	       param, function, unit;
 	GLfloat	       plane[4];
+	CompWindow     *p;
 
 	WATER_DISPLAY (w->screen->display);
 
@@ -1049,6 +1050,17 @@ waterDrawWindowTexture (CompWindow	     *w,
 	function = getBumpMapFragmentFunction (w->screen, texture, unit, param);
 	if (function)
 	{
+	    float dx = ws->tx / (GLfloat) w->screen->width;
+	    float dy = ws->ty / (GLfloat) w->screen->height;
+	    int   wx = 0;
+	    int   wy = 0;
+
+	    for (p = w->parent; p; p = p->parent)
+	    {
+		wx += p->attrib.x;
+		wy += p->attrib.y;
+	    }
+
 	    addFragmentFunction (&fa, function);
 
 	    screenLighting (w->screen, TRUE);
@@ -1058,16 +1070,16 @@ waterDrawWindowTexture (CompWindow	     *w,
 	    glBindTexture (ws->target, ws->texture[TINDEX (ws, 0)]);
 
 	    plane[1] = plane[2] = 0.0f;
-	    plane[0] = ws->tx / (GLfloat) w->screen->width;
-	    plane[3] = 0.0f;
+	    plane[0] = dx;
+	    plane[3] = dx * wx;
 
 	    glTexGeni (GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
 	    glTexGenfv (GL_S, GL_EYE_PLANE, plane);
 	    glEnable (GL_TEXTURE_GEN_S);
 
 	    plane[0] = plane[2] = 0.0f;
-	    plane[1] = ws->ty / (GLfloat) w->screen->height;
-	    plane[3] = 0.0f;
+	    plane[1] = dy;
+	    plane[3] = dy * wy;
 
 	    glTexGeni (GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
 	    glTexGenfv (GL_T, GL_EYE_PLANE, plane);
@@ -1268,7 +1280,8 @@ waterInitiate (CompDisplay     *d,
 	if (!ws->grabIndex)
 	    ws->grabIndex = pushScreenGrab (s, None, "water");
 
-	if (XQueryPointer (d->display, s->root, &root, &child, &xRoot, &yRoot,
+	if (XQueryPointer (d->display, s->root.id, &root, &child,
+			   &xRoot, &yRoot,
 			   &i, &i, &ui))
 	{
 	    XPoint p;
@@ -1594,7 +1607,8 @@ waterInitDisplay (CompPlugin  *p,
 {
     WaterDisplay *wd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     wd = malloc (sizeof (WaterDisplay));
diff --git a/plugins/wm.c b/plugins/wm.c
new file mode 100644
index 0000000..e797c36
--- /dev/null
+++ b/plugins/wm.c
@@ -0,0 +1,127 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#include <compiz-core.h>
+
+static CompMetadata wmMetadata;
+
+static CompOption *
+wmGetDisplayOptions (CompPlugin  *plugin,
+		     CompDisplay *display,
+		     int	 *count)
+{
+    *count = 1;
+    return &display->opt[COMP_DISPLAY_OPTION_ABI];
+}
+
+static Bool
+wmInitDisplay (CompPlugin  *p,
+	       CompDisplay *d)
+{
+    if (!checkPluginABI ("core", CORE_ABIVERSION))
+	return FALSE;
+
+    if (windowManagement)
+	return TRUE;
+
+    if (d->screens)
+    {
+	compLogMessage (p->vTable->name, CompLogLevelError,
+			"%s plugin must be loaded before screens are "
+			"initialize", p->vTable->name);
+	return FALSE;
+    }
+
+    windowManagement = TRUE;
+
+    return TRUE;
+}
+
+static CompBool
+wmInitObject (CompPlugin *p,
+	      CompObject *o)
+{
+    static InitPluginObjectProc dispTab[] = {
+	(InitPluginObjectProc) 0, /* InitCore */
+	(InitPluginObjectProc) wmInitDisplay
+    };
+
+    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
+}
+
+static CompOption *
+wmGetObjectOptions (CompPlugin *plugin,
+		    CompObject *object,
+		    int	       *count)
+{
+    static GetPluginObjectOptionsProc dispTab[] = {
+	(GetPluginObjectOptionsProc) 0, /* GetCoreOptions */
+	(GetPluginObjectOptionsProc) wmGetDisplayOptions
+    };
+
+    RETURN_DISPATCH (object, dispTab, ARRAY_SIZE (dispTab),
+		     (void *) (*count = 0), (plugin, object, count));
+}
+
+static Bool
+wmInit (CompPlugin *p)
+{
+    if (!compInitPluginMetadataFromInfo (&wmMetadata, p->vTable->name,
+					 0, 0, 0, 0))
+	return FALSE;
+
+    compAddMetadataFromFile (&wmMetadata, p->vTable->name);
+
+    return TRUE;
+}
+
+static void
+wmFini (CompPlugin *p)
+{
+    compFiniMetadata (&wmMetadata);
+}
+
+static CompMetadata *
+wmGetMetadata (CompPlugin *plugin)
+{
+    return &wmMetadata;
+}
+
+CompPluginVTable wmVTable = {
+    "wm",
+    wmGetMetadata,
+    wmInit,
+    wmFini,
+    wmInitObject,
+    0, /* FiniObject */
+    wmGetObjectOptions,
+    0  /* SetObjectOption */
+};
+
+CompPluginVTable *
+getCompPluginInfo20070830 (void)
+{
+    return &wmVTable;
+}
